unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Controls, Forms, WMPLib_TLB,
  Dialogs, Classes, OleCtrls, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    Panel2: TPanel;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure WindowsMediaPlayer1Click(Sender: TObject; nButton,
      nShiftState: Smallint; fX, fY: Integer);
    procedure Button1Click(Sender: TObject);
  private
    //  TWindowsMediaPlayer 𕔕iuɃo[ƂĒ`
    FPlayer: TWindowsMediaPlayer;
    //  TWindowsMediaPlayer 蒼
    procedure ReCreatePlayer();
  private
    //  TCYIuԂ𑨂
    FResized: Boolean;
    procedure OnResized();
    procedure WMEXITSIZEMOVE(var Message: TMessage); message WM_EXITSIZEMOVE;

  public
  end;

var
  Form1: TForm1;

implementation

uses Types;

{$R *.dfm}

//-----------------------------------------------------------------------------
//  TCYIuԂ𑨂
//  [Delphi-ML:20299] Window̃TCYCxgɂċĂB
procedure TForm1.WMEXITSIZEMOVE(var Message: TMessage);
begin
    if FResized then OnResized();
    inherited;
end;

//-----------------------------------------------------------------------------
//  TCYCxg
procedure TForm1.OnResized;
begin
    //  vC[j
    FPlayer.Free();
    FPlayer := nil;
    //  
    ReCreatePlayer();
    //  Đt@Cw肷
    //FPlayer.URL := '';
    //  \
    FPlayer.Show();

    Caption := IntToStr(StrToIntDef(Caption, 0) + 1);

    //  Ō1𑨂邽߂̃tOOFF
    FResized := False;
end;

//-----------------------------------------------------------------------------
//  tH[TCYύX
procedure TForm1.FormResize(Sender: TObject);
begin
    //  Ō1𑨂邽߂̃tOON
    FResized := True;
end;

//-----------------------------------------------------------------------------
//  TWindowsMediaPlayer 蒼
//  http://hpcgi1.nifty.com/MADIA/DelphiBBS/wwwlng.cgi?print+200711/07110026.txt
//  WindowsMediaPlayer1ς̍Đ\ɂ́H
procedure TForm1.ReCreatePlayer();
var
    LCore: IWMPCore;
    LPlayer4Disp: IWMPPlayer4Disp;
begin
    //  ĂȂ
    if not Assigned(FPlayer) then
    begin
        //  
        FPlayer := TWindowsMediaPlayer.Create(Self);
        //  TWindowsMediaPlayer R|̃TCY Form ̃TCYɍ킹
        FPlayer.Align := alClient;
        //  Align ̌ Parent ݒ(tƂ)
        FPlayer.Parent := Panel2;
        //  vC[̃C^[tF[Xo(?)
        LCore := FPlayer.ControlInterface;
        if Assigned(LCore) then
        begin
            //  StretchToFit ĂC^[tF[Xւ̎QƂo
            LCore.QueryInterface(IWMPPlayer4Disp, LPlayer4Disp);
            if Assigned(LPlayer4Disp) then
            begin
                //  ŁAݒ肷
                LPlayer4Disp.StretchToFit := True;
            end;
        end;

        FPlayer.OnClick := WindowsMediaPlayer1Click;
    end;
end;

//-----------------------------------------------------------------------------
//  tH[쐬
procedure TForm1.FormCreate(Sender: TObject);
begin
    FPlayer := nil;
end;

//-----------------------------------------------------------------------------
//  tH[j
procedure TForm1.FormDestroy(Sender: TObject);
begin
    //  vC[j
    FPlayer.Free();
    FPlayer := nil;
end;

//-----------------------------------------------------------------------------
//  tH[\
procedure TForm1.FormShow(Sender: TObject);
begin
    OnResized();
end;

//-----------------------------------------------------------------------------
//  t@CI
procedure TForm1.WindowsMediaPlayer1Click(Sender: TObject; nButton,
  nShiftState: Smallint; fX, fY: Integer);
begin
    if (OpenDialog1.Execute()) then
    begin
        FPlayer.URL := OpenDialog1.FileName;
    end;
end;

//-----------------------------------------------------------------------------
//  ő剻
//  WM_EXITSIZEMOVE  Player 蒼Ƃ ^Cgo[_uNbN
//  ^Cgo[̍ő剻{^⑫łȂBcO
procedure TForm1.Button1Click(Sender: TObject);
var
    R: TRect;
begin
    SystemParametersInfo(SPI_GETWORKAREA, 0, @R, 0);
    Self.Left := R.Left;
    Self.Top := R.Top;
    Self.Width := R.Right - R.Left; 
    Self.Height := R.Bottom - R.Top; 
    OnResized();
end;

end.
